/* -------------------------------------------------------------------- */
/* Programma: conteggio    Modulo: funzioni.c    Autore: Enrico Lodolo  */
/* Creato il 16/12/2002                    Ultima modifica: 16/12/2002  */
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funzioni.h"

/* -------------------------------------------------------------------- */
/*  3. Definizione funzione leggi()                                     */
/*     Legge da nomefile i dati delle righe nella struttura schedine    */
/* -------------------------------------------------------------------- */

int leggi(char nomefile[], schedine* sc)
{
  schedina s;
  FILE* f;

  f = fopen(nomefile, "r");

  if (f==NULL)
    return FALSE;
  else
  {
    sc->num = 0;

    while (fscanf(f, "%d/%d/%d %s",
	         &s.giorno, &s.mese, &s.anno, s.risultati)!=EOF)
    {
			s.num = 0;
      sc->sch[sc->num] = s;
      sc->num++;
    }
    fclose(f);
    return TRUE;
  }
}

/* -------------------------------------------------------------------- */
/*  5. Definizione funzione conta()                                     */
/*     Conta il numero vittorie in casa                                 */
/* ---------------------------------------------------------------------*/

int conta(char ris[])

{
  int i;
	int n = 0;

	for (i=0;i<strlen(ris);i++)
	  if (ris[i]=='1') n++;

  return n;
}

/* -------------------------------------------------------------------- */
/*  6. Definizione procedura elebora()                                  */
/*     Conta il numero di vittorie f.c. per ogni schedina               */
/* ---------------------------------------------------------------------*/

void elabora(schedine* sc)
{
	int i;

	for (i=0; i<sc->num; i++)
		sc->sch[i].num = conta(sc->sch[i].risultati);
}

/* ------------------------------------------------------------------- */
/*  7. Definizione funzione scrivi()                                   */
/*     Scrive nel file filename i contatori degli accessi              */
/* --------------------------------------------------------------------*/

int scrivi(char nomefile[], schedine sc)
{
  FILE *f;
  int i;

  f = fopen(nomefile, "w");

  if (f==NULL) return FALSE;
  else
  {
    for(i=0; i<sc.num; i++)
      fprintf(f, "%d/%d/%d %d\n", sc.sch[i].anno, sc.sch[i].mese, sc.sch[i].giorno, sc.sch[i].num);
    fclose(f);
    return TRUE;
  }
}

/* ------------------------------------------------------------------- */
/*  Definizione funzione errore() (non richiesta ma utile)             */
/*  Scrive a video un messaggio di errore e termina programma con      */
/*  valore di ritorno uguale al codice di errore                       */
/* --------------------------------------------------------------------*/

void errore(int n, char msg[])
{
  printf("%s\n",msg);
  exit(n);
}
